Index: CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js	(revision 5306)
@@ -162,4 +162,15 @@
 	}
 
+	function restoreSelection( selection )
+	{
+		if ( selection.isLocked )
+		{
+			selection.unlock();
+			setTimeout( function() { selection.lock(); }, 0 );
+		}
+	}
+
+	var isNotWhitespace = CKEDITOR.dom.walker.whitespaces( true );
+
 	/**
 	 *  Auto-fixing block-less content by wrapping paragraph (#3190), prevent
@@ -184,4 +195,6 @@
 		{
 			restoreDirty( editor );
+			CKEDITOR.env.ie && restoreSelection( selection );
+
 			var fixedBlock = range.fixBlock( true,
 					editor.config.enterMode == CKEDITOR.ENTER_DIV ? 'div' : 'p'  );
@@ -200,5 +213,4 @@
 				var previousElement = fixedBlock.getPrevious( isNotWhitespace ),
 					nextElement = fixedBlock.getNext( isNotWhitespace );
-
 
 				if ( previousElement && previousElement.getName
@@ -212,9 +224,4 @@
 				}
 			}
-
-			range.select();
-			// Notify non-IE that selection has changed.
-			if ( !CKEDITOR.env.ie )
-				editor.selectionChange();
 		}
 
@@ -222,13 +229,33 @@
 		// blocks (e.g. table, list, pre) at the end of document, make this happen by
 		// place a bogus node there, which would be later removed by dataprocessor.
-		var lastNode = body.getLast( CKEDITOR.dom.walker.whitespaces( true ) );
-		if ( lastNode && lastNode.getName && ( lastNode.getName() in nonExitableElementNames ) )
+		var walkerRange = new CKEDITOR.dom.range( editor.document ),
+			walker = new CKEDITOR.dom.walker( walkerRange );
+		walkerRange.selectNodeContents( body );
+		walker.evaluator = function( node )
+		{
+			return node.type == CKEDITOR.NODE_ELEMENT && ( node.getName() in nonExitableElementNames );
+		};
+		walker.guard = function( node, isMoveout )
+		{
+			return !( ( node.type == CKEDITOR.NODE_TEXT && isNotWhitespace( node ) ) || isMoveout );
+		};
+
+		if ( walker.previous() )
 		{
 			restoreDirty( editor );
+			CKEDITOR.env.ie && restoreSelection( selection );
+
+			var paddingBlock;
+			if ( enterMode != CKEDITOR.ENTER_BR )
+				paddingBlock = body.append( new CKEDITOR.dom.element( enterMode == CKEDITOR.ENTER_P ? 'p' : 'div' ) );
+			else
+				paddingBlock = body;
+
 			if ( !CKEDITOR.env.ie )
-				body.appendBogus();
-			else
-				body.append( editor.document.createText( '\xa0' ) );
+				paddingBlock.appendBogus();
 		}
+
+		range.select();
+		editor.selectionChange();
 	}
 
@@ -278,9 +305,5 @@
 							( isCustomDomain ? ( 'document.domain="' + document.domain + '";' ) : '' ) +
 
-							// With FF, it's better to load the data on
-							// iframe.load. (#3894,#4058)
-							// But in FF, we still need the open()-close() call
-							// to avoid HTTPS warnings.
-							( CKEDITOR.env.gecko ? '' : ( 'parent.CKEDITOR.tools.callFunction(' + setDataFn + ',document);' ) ) +
+							( ( 'parent.CKEDITOR.tools.callFunction(' + setDataFn + ',document);' ) ) +
 
 							'document.close();';
@@ -289,6 +312,9 @@
   							' style="width:100%;height:100%"' +
   							' frameBorder="0"' +
-  							' src="javascript:void(function(){' + encodeURIComponent( srcScript ) + '}())"' +
-  							' tabIndex="' + editor.tabIndex + '"' +
+  							' title="' + frameLabel + '"' +
+							// With FF, the 'src' attribute should be left empty to
+							// trigger iframe's 'load' event.
+  							' src="' + ( CKEDITOR.env.gecko ? '' : 'javascript:void(function(){' + encodeURIComponent( srcScript ) + '}())' ) + '"' +
+							' tabIndex="' + editor.tabIndex + '"' +
   							' allowTransparency="true"' +
   							'></iframe>' );
@@ -426,4 +452,5 @@
 										&& first.hasAttribute( '_moz_editor_bogus_node' ) )
 									{
+										restoreDirty( editor );
 										var keyEventSimulate = domDocument.$.createEvent( "KeyEvents" );
 										keyEventSimulate.initKeyEvent( 'keypress', true, true, domWindow.$, false,
@@ -652,4 +679,7 @@
 
 								CKEDITOR._[ 'contentDomReady' + editor.name ] = contentDomReady;
+
+								// The iframe is recreated on each call of setData, so we need to clear DOM objects
+								this.onDispose();
 								createIFrame( data );
 							},
@@ -689,6 +719,22 @@
 							},
 
+							onDispose : function()
+							{
+								if ( !editor.document )
+									return;
+
+								editor.document.getDocumentElement().clearCustomData();
+								editor.document.getBody().clearCustomData();
+
+								editor.window.clearCustomData();
+								editor.document.clearCustomData();
+
+								iframe.clearCustomData();
+							},
+
 							unload : function( holderElement )
 							{
+								this.onDispose();
+
 								editor.window = editor.document = iframe = mainElement = isPendingFocus = null;
 
@@ -703,23 +749,4 @@
 								{
 									editor.window.focus();
-
-									// Force the selection to happen, in this way
-									// we guarantee the focus will be there. (#4848)
-									if ( CKEDITOR.env.ie )
-									{
-										try
-										{
-											var sel = editor.getSelection();
-											sel = sel && sel.getNative();
-											var range = sel && sel.type && sel.createRange();
-											if ( range )
-											{
-													sel.empty();
-													range.select();
-											}
-										}
-										catch (e) {}
-									}
-
 									editor.selectionChange();
 								}
@@ -758,4 +785,8 @@
 							editor.focus();
 						} );
+				} );
+				editor.on( 'destroy', function()
+				{
+					ieFocusGrabber.clearCustomData();
 				} );
 			}
Index: CKEditor/branches/versions/3.3.x/_source/skins/kama/skin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/skins/kama/skin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/skins/kama/skin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/themes/default/theme.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/themes/default/theme.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/themes/default/theme.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -230,4 +230,6 @@
 		{
 			var container = editor.container;
+			container.clearCustomData();
+			editor.element.clearCustomData();
 
 			/*
@@ -257,8 +259,7 @@
 
 			if ( editor.elementMode == CKEDITOR.ELEMENT_MODE_REPLACE )
-			{
 				editor.element.show();
-				delete editor.element;
-			}
+
+			delete editor.element;
 		}
 	};
Index: CKEditor/branches/versions/3.3.x/ckeditor.pack
===================================================================
--- CKEditor/branches/versions/3.3.x/ckeditor.pack	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/ckeditor.pack	(revision 5306)
@@ -1,3 +1,3 @@
-﻿/*
+/*
  * CKPackager - Sample Package file
  */
Index: CKEditor/branches/versions/3.3.x/ckeditor_basic_source.js
===================================================================
--- CKEditor/branches/versions/3.3.x/ckeditor_basic_source.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/ckeditor_basic_source.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/config.js
===================================================================
--- CKEditor/branches/versions/3.3.x/config.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/config.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
